

#include <QApplication>
#include "window.h"
#include "devices.h"
#include <QtCore>
//#include <KDE/KApplication>
//#include <KDE/KAboutData>
//#include <KDE/KCmdLineArgs>
//#include <KDE/KLocale>
// KDE
#include <KAboutData>
#include <klocalizedstring.h>

using namespace Solid;

int main(int argc, char *argv[])
{  

    QApplication app(argc, argv);

    KLocalizedString::setApplicationDomain("quickusbformatter");

    KAboutData aboutData(
                         // The program name used internally. (componentName)
                         QStringLiteral("quickusbformatter"),
                         // A displayable program name string. (displayName)
                         i18n("USB Format"),
                         // The program version string. (version)
                         //KCM_QUF_VERSION,
                         QStringLiteral("1.0"),
                         // Short description of what the app does. (shortDescription)
                         i18n("USB Format"),
                         // The license this code is released under
                         KAboutLicense::GPL_V3,
                         // Copyright Statement (copyrightStatement = QString())
                         i18n("(c) 2016"),
                         // Optional text shown in the About box.
                         // Can contain any information desired. (otherText)
                         i18n("A KDE Control Module for formatting USB devices"),
                         // The program homepage string. (homePageAddress = QString())
                         QStringLiteral("https://chakralinux.org"),
                         // The bug report email address
                         // (bugsEmailAddress = QLatin1String("submit@bugs.kde.org")
                         QStringLiteral("submit@bugs.kde.org"));


    aboutData.addAuthor("José Antonio Sánchez Reynaga", i18n("Creator"), "");
    aboutData.addAuthor("Luca Giambonini", i18n("Developer"), "almack@chakralinux.org");

    KAboutData::setApplicationData(aboutData);

    QCommandLineParser parser;
    parser.addHelpOption();
    parser.addVersionOption();
    parser.addPositionalArgument(QStringLiteral("+udi <argument>"), i18n("Device"));

    aboutData.setupCommandLine(&parser);
    parser.process(app);

    aboutData.processCommandLine(&parser);
    
    /*
    * If exactly three arguments are present, hopefully it was called from the device notifier
    */
    DeviceList devList;
    if (parser.positionalArguments().count() > 1)
        {
        Device device(parser.positionalArguments().at(1));
        devList.setDeviceNotifier(device);
    }

    /* Creating main window */
    Window *w = new Window(devList);
    w->show();
    app.exec();
}



